]> git.zerfleddert.de Git - m1-debian/blobdiff - gpu.sh
more todo
[m1-debian] / gpu.sh
diff --git a/gpu.sh b/gpu.sh
index 69c8dbaec3110e24a023ca1ee661ef9094ceba62..65ad62840bc073c38e46f383f4d53b4c8409a9db 100644 (file)
--- a/gpu.sh
+++ b/gpu.sh
@@ -1,9 +1,13 @@
-#!/bin/bash
+#!/usr/bin/env bash
 
 # SPDX-License-Identifier: MIT
 
-set -x
-set -e
+set -o errexit
+set -o nounset
+set -o pipefail
+set -o xtrace
+
+cd "$(dirname "$0")"
 
 unset LC_CTYPE
 unset LANG
@@ -14,12 +18,11 @@ build_linux()
         test -d linux || git clone https://github.com/AsahiLinux/linux
         cd linux
         git fetch -a -t
-        git reset --hard origin/asahi-wip; git clean -f -x -d &> /dev/null
-        curl -sL https://raw.githubusercontent.com/AsahiLinux/PKGBUILDs/main/linux-asahi/config > .config
-        make olddefconfig
-        make -j `nproc` V=0 > /dev/null
-        sudo make modules_install
-        sudo make install
+        git reset --hard asahi-6.1-rc8-3;
+        source "$HOME/.cargo/env"
+        cat ../../config-gpu.txt > .config
+        make LLVM=-15 olddefconfig
+        make -j `nproc` LLVM=-15 V=0 bindeb-pkg > /dev/null
 )
 }
 
@@ -29,7 +32,7 @@ build_m1n1()
         test -d m1n1 || git clone --recursive https://github.com/AsahiLinux/m1n1
         cd m1n1
         git fetch -a -t
-        git reset --hard origin/lina/gpu-wip; git clean -f -x -d &> /dev/null
+        git reset --hard v1.2.3;
         make -j `nproc`
 )
 }
@@ -40,17 +43,46 @@ build_uboot()
         test -d u-boot || git clone https://github.com/AsahiLinux/u-boot
         cd u-boot
         git fetch -a -t
-        # For tag, see https://github.com/AsahiLinux/PKGBUILDs/blob/main/uboot-asahi/PKGBUILD
-        git reset --hard origin/asahi; git clean -f -x -d &> /dev/null
-        curl -s https://tg.st/u/0001-usb-request-on-8-bytes-for-USB_SPEED_FULL-bMaxPacket.patch | git am -
+        git reset --hard asahi-v2022.10-1;
+
         make apple_m1_defconfig
         make -j `nproc`
 )
-
         cat m1n1/build/m1n1.bin   `find linux/arch/arm64/boot/dts/apple/ -name \*.dtb` <(gzip -c u-boot/u-boot-nodtb.bin) > u-boot.bin
-        sudo cp /boot/efi/m1n1/boot.bin /boot/efi/m1n1/`date +%Y%m%d%H%M`.bin
-        sudo cp u-boot.bin /boot/efi/m1n1/boot.bin
+}
+
+package_boot_bin()
+{
+(
+        export M1N1_VERSION=1.2.3-2
+        rm -rf m1n1_${M1N1_VERSION}_arm64
+        mkdir -p m1n1_${M1N1_VERSION}_arm64/DEBIAN m1n1_${M1N1_VERSION}_arm64/usr/lib/m1n1/
+        cp u-boot.bin m1n1_${M1N1_VERSION}_arm64/usr/lib/m1n1/boot.bin
+        cat <<EOF > m1n1_${M1N1_VERSION}_arm64/DEBIAN/control
+Package: m1n1
+Version: $M1N1_VERSION
+Section: base
+Priority: optional
+Architecture: arm64
+Maintainer: Thomas Glanzmann <thomas@glanzmann.de>
+Description: Apple silicon boot loader
+ Next to m1n1 this also contains the device trees and u-boot.
+EOF
+
+        cat > m1n1_${M1N1_VERSION}_arm64/DEBIAN/postinst <<EOF
+#!/bin/bash
+
+export PATH=/bin
+if [ -f /boot/efi/m1n1/boot.bin ]; then
+        cp /boot/efi/m1n1/boot.bin /boot/efi/m1n1/`date +%Y%m%d%H%M`.bin
+fi
+mkdir -p /boot/efi/m1n1/
+cp /usr/lib/m1n1/boot.bin /boot/efi/m1n1/
+EOF
 
+        chmod 755 m1n1_${M1N1_VERSION}_arm64/DEBIAN/postinst
+        dpkg-deb --build m1n1_${M1N1_VERSION}_arm64
+)
 }
 
 mkdir -p build
@@ -59,3 +91,4 @@ cd build
 build_linux
 build_m1n1
 build_uboot
+package_boot_bin
Impressum, Datenschutz